Attribute VB_Name = "NewMacros"
' Scan for Word 2013
' Author: Gnter Born www.borncity.de blog.borncity.com
' Implements a Scan function in Word 2013

Private Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long

Private Function TempPath() As String
  Const MaxPathLen = 256 ' Max length of the path, just as big as possible
 
  Dim FolderName As String ' Name of the folder
  Dim ReturnVar As Long ' Return Value
 
  FolderName = String(MaxPathLen, 0)
  ReturnVar = GetTempPath(MaxPathLen, FolderName)
 
  If ReturnVar <> 0 Then
    TempPath = Left(FolderName, InStr(FolderName, Chr(0)) - 1)
  Else
    TempPath = vbNullString
  End If
End Function

Sub Scan()
'
' Scan Macro, to be invoked in Word
'
  On Error Resume Next
     Dim objCommonDialog As WIA.CommonDialog
     Dim objImage As WIA.ImageFile
     Dim strDateiname
     ' instantiate Scan WIA objects
     Set objCommonDialog = New WIA.CommonDialog
     Set objImage = objCommonDialog.ShowAcquireImage
      
     strDateiname = TempPath & "Scan.jpg" ' set temporary file
     
     If Not objImage Is Nothing Then
       Kill strDateiname
       objImage.SaveFile strDateiname ' save into temp file
       Selection.InlineShapes.AddPicture strDateiname ' insert into document
       Set objImage = Nothing
     End If
     Set objCommonDialog = Nothing
 
   ' MsgBox strDateiname  ' test output
End Sub
